package javax.management;

import java.util.Iterator;
import java.util.Collection;
import java.util.List;
import java.util.ArrayList;

public class AttributeList extends ArrayList<Object>
{
    private transient volatile boolean typeSafe;
    private transient volatile boolean tainted;
    private static final long serialVersionUID = -4077085769279709076L;
    
    public AttributeList() {
    }
    
    public AttributeList(int initialCapacity) {
        super(initialCapacity);
    }
    
    public AttributeList(AttributeList c) {
        super(c);
    }
    
    public AttributeList(List<Attribute> c) {
        if (c == null) {
            throw new IllegalArgumentException("Null parameter");
        }
        this.adding(c);
        super.addAll(c);
        return;
    }
    
    public List<Attribute> asList() {
        this.typeSafe = true;
        if (this.tainted) {
            this.adding(this);
            return this;
        }
        return this;
    }
    
    public void add(Attribute e) {
        super.add(e);
    }
    
    public void add(int index, Attribute element) {
        try {
            super.add(index, element);
        }
        catch (IndexOutOfBoundsException ex) {
            throw new RuntimeOperationsException(ex, "The specified index is out of range");
        }
    }
    
    public void set(int index, Attribute element) {
        try {
            super.set(index, element);
        }
        catch (IndexOutOfBoundsException ex) {
            throw new RuntimeOperationsException(ex, "The specified index is out of range");
        }
    }
    
    public boolean addAll(AttributeList c) {
        return super.addAll(c);
    }
    
    public boolean addAll(int index, AttributeList c) {
        try {
            return super.addAll(index, c);
        }
        catch (IndexOutOfBoundsException ex) {
            throw new RuntimeOperationsException(ex, "The specified index is out of range");
        }
    }
    
    @Override
    public boolean add(Object e) {
        this.adding(e);
        return super.add(e);
    }
    
    @Override
    public void add(int index, Object element) {
        this.adding(element);
        super.add(index, element);
    }
    
    @Override
    public boolean addAll(Collection<?> c) {
        this.adding(c);
        return super.addAll(c);
    }
    
    @Override
    public boolean addAll(int index, Collection<?> c) {
        this.adding(c);
        return super.addAll(index, c);
    }
    
    @Override
    public Object set(int index, Object element) {
        this.adding(element);
        return super.set(index, element);
    }
    
    private void adding(Object obj) {
        if (obj == null || obj instanceof Attribute) {
            return;
        }
        if (this.typeSafe) {
            throw new IllegalArgumentException("Not an Attribute: " + obj);
        }
        this.tainted = true;
        return;
    }
    
    private void adding(Collection<?> collection) {
        Iterator<Object> iterator = collection.iterator();
        while (iterator.hasNext()) {
            this.adding(iterator.next());
        }
    }
}
